import React, { PureComponent } from 'react';

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  subClass.__proto__ = superClass;
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

var State = require("jstates");
function subscribe(Compt, statesToSubscribeTo, mapStatesToProps, stateKeysToListenTo) {
  if (statesToSubscribeTo === void 0) {
    statesToSubscribeTo = [];
  }

  if (mapStatesToProps === void 0) {
    mapStatesToProps = function mapStatesToProps(f) {
      return f;
    };
  }

  if (stateKeysToListenTo === void 0) {
    stateKeysToListenTo = [];
  }

  if (!Compt) {
    throw new Error("subscribe was called without a component or callback. subscribe(Component | callback, [statesToSubscribeTo], mapStatesToProps)");
  }

  if (statesToSubscribeTo.length < 1) {
    throw new Error("subscribe was called without states to subscribe to. subscribe(Component, [statesToSubscribeTo], mapStatesToProps)");
  }

  return (
    /*#__PURE__*/
    function (_PureComponent) {
      _inheritsLoose(Subscribe, _PureComponent);

      function Subscribe(props) {
        var _this;

        _this = _PureComponent.call(this, props) || this;
        _this.mounted = true;
        _this.onUpdate = _this.onUpdate.bind(_assertThisInitialized(_this));
        statesToSubscribeTo.forEach(function (state) {
          state.subscribe(_this.onUpdate);
        });
        _this.state = _this.generateState();
        return _this;
      }

      var _proto = Subscribe.prototype;

      _proto.generateState = function generateState() {
        var subscribedStates = {};
        statesToSubscribeTo.forEach(function extractState(_ref) {
          var name = _ref.name,
              state = _ref.state;
          subscribedStates[name] = state;
        });
        return mapStatesToProps(subscribedStates);
      };

      _proto.componentWillUnmount = function componentWillUnmount() {
        var _this2 = this;

        this.mounted = false;
        statesToSubscribeTo.forEach(function (state) {
          state.unsubscribe(_this2.onUpdate);
        });
      };

      _proto.onUpdate = function onUpdate(keysChanged) {
        var _this3 = this;

        if (keysChanged === void 0) {
          keysChanged = [];
        }

        return new Promise(function (resolve) {
          if (_this3.mounted) {
            if (!keysChanged.length || stateKeysToListenTo.length && !stateKeysToListenTo.find(function (key) {
              return keysChanged.indexOf(key) > -1;
            })) {
              resolve();
              return;
            }

            _this3.setState(_this3.generateState(), resolve);
          } else {
            resolve();
          }
        });
      };

      _proto.render = function render() {
        return React.createElement(Compt, _extends({}, this.props, this.state));
      };

      return Subscribe;
    }(PureComponent)
  );
}

export { State, subscribe };
